jQuery(document).ready(function($) {
	$('.no-click-through').on('click', function(e) {
		return false;
	});
	$('[preview-update-target]').on('change propertychange keyup input paste', function(e) {
		var target_selector = $(this).attr('preview-update-target');
		$(target_selector).html($(this).val()).resize();
	});
	$('[preview-update-target-value]').on('change propertychange keyup input paste', function(e) {
		var target_selector = $(this).attr('preview-update-target-value');
		$(target_selector).val($(this).val()).resize();
	});
	$('[preview-update-target-img]').on('change paste', function(e) {
		var target_selector = $(this).attr('preview-update-target-img');
		$(target_selector).attr('src', $(this).val()).resize();
	});
	function popupally_pro_get_image_size(url, width_element, height_element){
		var tmp_image = new Image();
		tmp_image.src=url;
		$(tmp_image).on('load',function(){
		  width_element.val(tmp_image.width).change();
		  height_element.val(tmp_image.height).change();
		});
	}
	$('[preview-update-target-css-background-img]').on('change paste', function(e) {
		var elem = $(this),
		target_selector = elem.attr('preview-update-target-css-background-img'),
		val = elem.val(),
		dimension_selector = elem.attr('image-dimension-attribute');
		if (val) {
			$(target_selector).css('background-image', 'url(' + val + ')').resize();
			if (dimension_selector) {
				popupally_pro_get_image_size(val, $('#' + dimension_selector + '-width'), $('#' + dimension_selector + '-height'));
			}
		} else {
			$(target_selector).css('background-image', 'none').resize();
			if (dimension_selector) {
				$('#' + dimension_selector + '-width').val('0').change();
				$('#' + dimension_selector + '-height').val('0').change();
			}
		}
	});
	$('[preview-update-target-css][preview-update-target-css-property]').on('change propertychange keyup input paste', function(e) {
		var elem = $(this),
		is_color_picker = elem.hasClass('nqpc-picker-input-iyxm'),
		target_selector = elem.attr('preview-update-target-css'),
		css_property = elem.attr('preview-update-target-css-property'),
		val = elem.val();
		if (is_color_picker) {
			if (val) {
				if ('#' !== val[0]) {
					val = '#' + val;
				}
				val += '000000';
				val = val.substring(0, 7);
				$(target_selector).css(css_property, val);
			} else {
				$(target_selector).css(css_property, 'transparent');
			}
		} else if (elem.val() !== 'other') {
			$(target_selector).css(css_property, val).resize();
		}
	});
	$('[preview-update-target-css][preview-update-target-css-property-px]').on('change propertychange keyup input paste', function(e) {
		var target_selector = $(this).attr('preview-update-target-css'),
		css_property = $(this).attr('preview-update-target-css-property-px');
		$(target_selector).css(css_property, $(this).val() + 'px').resize();
		if ('border-radius' === css_property) {
			$(target_selector).css('-moz-border-radius', $(this).val() + 'px').css('-webkit-border-radius', $(this).val() + 'px').resize();
		}
	});
	$('[preview-update-target-css-hide]').on('change', function(e) {
		var target_selector = $(this).attr('preview-update-target-css-hide');
		$(target_selector).css('display', $(this).val()).resize();
	});
	$("[preview-update-target-hide-checked]").on('change propertychange keyup input paste', function(e) {
		var selector = $(this).attr('preview-update-target-hide-checked');
		if ($(this).attr('checked')) {
			$(selector).hide().resize();
		} else {
			$(selector).show().resize();
		}
	});
	$('[preview-update-target-placeholder]').on('change propertychange keyup input paste', function(e) {
		var target_selector = $(this).attr('preview-update-target-placeholder');
		$(target_selector).attr('placeholder', $(this).val()).resize();
	});
	var placeholder_style = null,
	current_rules = {},
	placeholder_rule_tempalte = '{{target}}::-webkit-input-placeholder{color:{{val}};}{{target}}:-moz-placeholder{color:{{val}};}{{target}}::-moz-placeholder{color:{{val}};}';
	function add_placeholder_color(element_name, color){
		var rule_string = '',key=0;
		if (null === placeholder_style){
			var style = document.createElement('style');
			placeholder_style = $(style);
			placeholder_style.attr('type', "text/css");
			placeholder_style.attr('id', "inlinestyle");

			$('head').append(style);
		}
		element_name = 'input[type="text"]'+element_name;
		if (jQuery.browser.msie == true){
			rule_string = element_name + ':-ms-input-placeholder{', 'color:'+color+';}';
			if (element_name in current_rules) {
				document.styleSheets.inlinestyle.deleteRule(current_rules[element_name]);
				document.styleSheets.inlinestyle.insertRule(rule_string, current_rules[element_name]);
			} else {
				document.styleSheets.inlinestyle.addRule(element_name + ':-ms-input-placeholder', 'color:'+color+';');
				current_rules[element_name] = document.styleSheets.inlinestyle.rules.length - 1;
			}
		}else{
			current_rules[element_name] = color;
			for(key in current_rules) {
				rule_string += placeholder_rule_tempalte.replace(/{{target}}/g, key).replace(/{{val}}/g, current_rules[key]);
			}
			placeholder_style.text(rule_string);
		}
	}
	$('[preview-update-target-input-color]').on('change propertychange keyup input paste', function(e) {
		var $this = $(this),
		target_selector = $(this).attr('preview-update-target-input-color'),
		val = $this.val();
		$(target_selector).css('color', val).resize();
		add_placeholder_color(target_selector, val);
	});
});