var PopupAllyProDependencyBinder = (function() {
	var self = {}, $ = jQuery;

	self.bind_dependency_elements = function() {
		var bound_dependency_elements = {},
			all_dependent_elements = $('[data-dependency]');
		all_dependent_elements.each(function() {
			var name = $(this).attr('data-dependency');
			if (!(name in bound_dependency_elements)) {
				bound_dependency_elements[name] = false;
			}
		});
		for (var key in bound_dependency_elements) {
			$('#' + key).on('change', function() {
				var $element = $(this),
					value = 'false',
					dependency_name = $element.attr('id'),
					dependencies = null,
					sub_filter = null;
				if (false === bound_dependency_elements[dependency_name]) {
					bound_dependency_elements[dependency_name] = all_dependent_elements.filter('[data-dependency="' + dependency_name + '"]')
				}
				dependencies = bound_dependency_elements[dependency_name];
				if($element.is('[type="checkbox"]')) {
					if ($element.is(':checked')){
						value = 'true';
					}
				} else {
					value = $element.val();
				}

				sub_filter = dependencies.filter('[hide-toggle]');
				sub_filter.hide();
				sub_filter.filter('[data-dependency-value="' + value + '"]').show();

				sub_filter = dependencies.filter('[readonly-toggle]');
				sub_filter.prop('readonly', true);
				sub_filter.filter('[data-dependency-value="' + value + '"]').prop('readonly', false);
			});
		}
	};
	return self;
})();

jQuery(document).ready(function($) {
	$("textarea").change(function() {
		$(this).text($(this).val());
	});

	$("select").change(function() {
		var sel = $(this).children(":selected");
		$(this.children).not(sel).removeAttr("selected");
		sel.attr("selected", "selected");
	});
	function serialize_form_values($parent_form) {
		$('.popupally-pro-option-setting-form[serialize-target]').each(function() {
			var $this = $(this),
				target = $this.attr('serialize-target'),
				new_form = $("<form></form>");
			$this.children().clone().appendTo(new_form);
			$('.' + target).val(JSON.stringify(new_form.serializeArray()));
			copy_file_input($parent_form, $this);
		});
	}
	function copy_file_input($parent_form, $source_form) {
		$source_form.find('input[type=file]').each(function() {
			if ($(this).val()) {
				$parent_form.append($(this).hide());
			}
		});
	}
	$('.popupally-setting-submit-button').on('click', function(e) {
		if ($('.delete-popup-checkbox:checked').length > 0) {
			var conf = confirm("Deleted popups cannot be restored. Do you want to continue?");
			if(conf !== true){
				return false;
			}
		}
		serialize_form_values($(this).parents('form'));
		return true;
	});
	var all_popupally_pro_follow_scroll = $('.follow-scroll'),
		all_popupally_pro_tab_group = $('[tab-group]'),
		all_popupally_pro_name_sync_master = $('[name-sync-master]'),
		all_popupally_pro_name_sync_text = $('[name-sync-text]'),
		all_popupally_pro_name_sync_val = $('[name-sync-val]'),
		all_popupally_pro_template_warning_targets = $('[template-warning-target]'),
		all_popupally_pro_signup_fields =  $('[signup-html-template]'),
		all_popupally_pro_update_follow_scroll_group = $('.popupally-update-follow-scroll-group'),
		popupally_pro_hide_form_selection = $("[signup-form-hide]"),
		popupally_pro_follow_scroll = $(),
		popupally_pro_all_sign_up_form_html = $('.sign-up-form-raw-html'),
		popupally_pro_all_false_check = $('[input-all-false-check]'),
		popupally_pro_template_selection = $('.popupally-setting-style-template-select'),
		popupally_pro_toggle_groups = new Object;
	PopupAllyProDependencyBinder.bind_dependency_elements();
	function resize_follow_scroll() {
		if (popupally_pro_follow_scroll) {
			popupally_pro_follow_scroll.resize();
		}
	}
	$("[click-target][click-value]").on('click', function(e) {
		var selector = $(this).attr('click-target');
		$(selector).val($(this).attr('click-value')).change();
		resize_follow_scroll();
		return false;
	});
	$("[input-empty-check]").on('change propertychange keyup input paste', function(e) {
		var selector = $(this).attr('input-empty-check');
		if ($(this).val()) {
			$(selector).val('block').change();
		} else {
			$(selector).val('none').change();
		}
		resize_follow_scroll();
	});
	$("[input-all-empty-check]").on('change propertychange keyup input paste', function(e) {
		var is_empty = true;
		var selector = $(this).attr('input-all-empty-check');
		$('[input-all-empty-check=' + selector + ']').each(function(index) {
			if ($(this).val()) {
				is_empty = false;
			}
		});
		if (is_empty) {
			$(selector).val('none').change();
		} else {
			$(selector).val('block').change();
		}
		resize_follow_scroll();
	});
	popupally_pro_all_false_check.on('change propertychange', function(e) {
		var selector = $(this).attr('input-all-false-check'),
		is_checked = popupally_pro_all_false_check.filter('[input-all-false-check=' + selector + ']:checked').length > 0;
		if (is_checked) {
			$('.' + selector).show();
		} else {
			$('.' + selector).hide();
		}
		resize_follow_scroll();
	});
	popupally_pro_all_sign_up_form_html.change(function(e) {
		var $this = $(this),
		id = $this.attr('popup-id'),
		$error = $('#sign-form-error-' + id),
		$parent = $this.parent(),
		form_code = $.trim($this.val()),
		form_action_element = $('#sign-up-form-action-' + id),
		form_valid_element = $('#sign-up-form-valid-' + id),
		form_select_element = $('.sign-up-form-select-' + id),
		$parsed_form = null;

		$error.hide();
		$('.sign-up-form-generated-' + id).remove();
		if('' === form_code) {
			form_action_element.val('');
			form_select_element.empty().append($('<option></option>').attr('value', ':null:'));
			form_valid_element.val('false').change();
			return;
		}
		try{
			$parsed_form = $(form_code);
		}catch(e){
			$error.show().text('Invalide form code. Please copy the entire HTML code block from your mailing list provider into the Sign-up form HTML field.');
			form_action_element.val('');
			form_select_element.empty().append($('<option></option>').attr('value', ':null:'));
			form_valid_element.val('false').change();
			return;
		}

		var $form = $parsed_form.find('form');
		if(0 === $form.size()) {
			$form = $parsed_form.filter('form');
		}
		if(0 === $form.size()) {
			$error.show().text('A <form> element could not be found in the Sign-up form HTML Code you entered. Please copy the entire HTML code block from your mailing list provider into the Sign-up form HTML field.');
			form_action_element.val('');
			form_select_element.empty().append($('<option></option>').attr('value', ':null:'));
			form_valid_element.val('false').change();
			return;
		}
		form_valid_element.val('true').change();

		form_action_element.val($form.attr('action'));

		var other_inputs = [''];
		var lowercased = '';
		var email_input_name = '';
		var name_input_name = '';
		var count = 0;

		$parsed_form.find('input[type!="submit"]').each(function(index, input) {
			var $input = $(input),
			input_name =$input.attr('name'),
			input_type = $input.attr('type'),
			input_value = $input.val();

			if (input_name) {
				count += 1;
				if('hidden' === input_type) {
					$parent.before($('<input class="sign-up-form-generated-' + id + '" type="hidden" name="[' + id + '][hidden-form-fields-name][' + count + ']"/>').val(input_name));
					$parent.before($('<input class="sign-up-form-generated-' + id + '" type="hidden" name="[' + id + '][hidden-form-fields-value][' + count + ']"/>').val(input_value));
				} else {
					$parent.before($('<input class="sign-up-form-generated-' + id + '" type="hidden" name="[' + id + '][other-form-fields-name][' + count + ']"/>').val(input_name));
					$parent.before($('<input class="sign-up-form-generated-' + id + '" type="hidden" name="[' + id + '][other-form-fields-value][' + count + ']"/>').val(input_value));
					other_inputs.push(input_name);

					lowercased = input_name.toLowerCase();

					if('' === email_input_name && -1 < lowercased.indexOf('email')) {
						email_input_name = input_name;
					} else if('' === name_input_name && -1 < lowercased.indexOf('name')) {
						name_input_name = input_name;
					}
				}
			}
		});

		form_select_element.each(function(index, select) {
			var $select = $(select);
			var previous_value = $select.val();
			var splash_field = $select.attr('sign-up-form-field');

			$select.empty();

			$.each(other_inputs, function(other_inputs_index, other_input) {
				$select.append($('<option></option>').attr('value', other_input).text(other_input));
			});

			if(':null:' !== previous_value && -1 < $.inArray(previous_value, other_inputs)) {
				$select.val(previous_value);
			} else {
				if('email' === splash_field && '' !== email_input_name) {
					$select.val(email_input_name).change();
				} else if('name' === splash_field && '' !== name_input_name) {
					$select.val(name_input_name).change();
				}
			}
		});
	});
	$(window).on('scroll', function(e) {
		var window_view_top = $(window).scrollTop(),
			window_view_bottom = window_view_top + $(window).height();
		if (popupally_pro_follow_scroll){
			popupally_pro_follow_scroll.each(function(index, elem){
				var $elem = $(elem),
					$parent = $elem.parent(),
					parent_top = $parent.offset().top,
					parent_height = $parent.height(),
					parent_width = $parent.width(),
					parent_bottom = parent_top + parent_height,
					elem_height = $elem.height() + 30,
					offset = 0,
					step_aside = $elem.hasClass('step-aside');
				if (!(parent_top > window_view_bottom || parent_bottom < window_view_top)) {
					parent_top = parent_top - 30;
					offset = Math.min(Math.max(0, window_view_top - parent_top), parent_height - elem_height);
					$elem.css('margin-top', offset);
					if (step_aside) {
						if (offset > 0) {
							$elem.css('margin-left', parent_width+50);
						} else {
							$elem.css('margin-left', 0);
						}
					}
				}
			});
		}
	});
	function collapse_all_popups(group, except){
		var index = 0,
			elem = null,
			elems = null,
			selector = '',
			is_checked = false;
		if (!(group in popupally_pro_toggle_groups)){
			popupally_pro_toggle_groups[group] = $('[toggle-group="' + group + '"]');
		}
		elems = popupally_pro_toggle_groups[group];
		for (index = 0;index<elems.length;++index) {
			elem = $(elems[index]);
			selector = elem.attr('toggle-element');
			if (selector !== except) {
				is_checked = elem.prop('checked');
				if (is_checked) {
					elem.prop('checked', false).change();
				}
			}
		}
	}
	$("[toggle-element]").on('change propertychange keyup input paste', function(e) {
		var $this = $(this),
			selector = $this.attr('toggle-element'),
			target = $(selector),
			group = $this.attr('toggle-group'),
			toggle_class = $this.attr('toggle-class'),
			is_checked = $this.prop('checked'),
			orig_height = target.outerHeight(true),
			min_height = $this.attr('min-height');
		if (is_checked) {
			collapse_all_popups(group, selector);
			target.animate({height:orig_height + 'px'}, 200, function() {$(selector).css('overflow', 'visible').css('height', 'auto');}).addClass(toggle_class);
		} else {
			target.addClass(toggle_class).animate({height:min_height + 'px'}, 200, function() {$(selector).css('overflow', 'hidden');}).removeClass(toggle_class);
		}
		$(".popupally-name-edit").filter(":focus").focusout();
	});
	function update_follow_scroll(popup_id, selected_template) {
		popupally_pro_follow_scroll = all_popupally_pro_follow_scroll.filter('[popup-id="' + popup_id + '"][template-id="' + selected_template + '"]');
		popupally_pro_follow_scroll.resize();
	}
	function update_signup_field_hide_status(popup_id, selected_template) {
		var index = 0,
			target = '',
			active = popupally_pro_hide_form_selection.filter('[popup-id="' + popup_id + '"][template-id="' + selected_template + '"]');
		for (index = 0;index < active.length; ++index){
			target = active[index].attributes['signup-form-hide'].value;
			if (active[index].checked) {
				all_popupally_pro_signup_fields.filter('[popup-id="' + popup_id + '"][signup-html-template="' + target + '"]').hide();
			}else{
				all_popupally_pro_signup_fields.filter('[popup-id="' + popup_id + '"][signup-html-template="' + target + '"]').show();
			}
		}
	}
	popupally_pro_template_selection.on('change', function(e) {
		var $this = $(this),
			index = 0,
			id = $this.attr('popup-id'),
			advanced = $('#advanced-'+id).val(),
			selected = $this.val(),
			affected = all_popupally_pro_template_warning_targets.filter('[popup-id="' + id + '"]'),
			warning_template = '';

		if (advanced !== 'true') {
			for (index = 0; index < affected.length; ++index) {
				warning_template = affected[index].attributes['template-warning-target'].value;
				if (warning_template.indexOf(selected) < 0) {
					affected[index].className = '';
				} else {
					affected[index].className = 'template-select-warning';
				}
			}
		}
		update_follow_scroll(id, selected);
		update_signup_field_hide_status(id, selected);
	});
	$(".popupally-header").on('click', function(e) {
		var selector = $(this).attr('toggle-target');
		$(selector).prop('checked', !$(selector).prop('checked'));
		$(selector).change();
	});
	$(".popupally-style-header-name").on('click', function(e) {
		e.stopPropagation();
	});
	$("[export-link][export-selection]").on('click', function(e) {
		var selector = $(this).attr('export-selection'),
		link = $(this).attr('export-link');
		link = link + '&id=' + $(selector).val();
		window.open(link, '_blank');
		return false;
	});
	function parse_key_from_name(name){
		if (undefined === name) {
			return '';
		}
		var first = name.indexOf('['),
			start = name.indexOf('[', first + 1),
			end = name.indexOf(']', start);
		if (start < 0 || end < 0) {
			return '';
		}
		return name.substring(start+1, end);
	}
	function parse_second_key_from_name(name){
		if (undefined === name) {
			return '';
		}
		var first = name.indexOf('['),
			second = name.indexOf('[', first + 1),
			start = name.indexOf('[', second + 1),
			end = name.indexOf(']', start);
		if (start < 0 || end < 0) {
			return '';
		}
		return name.substring(start+1, end);
	}
	function assign_import_values(setting_variable, id, default_setting, imported_setting) {
		var $parent = $('div[serialize-target=' + setting_variable + ']'),
			base_name = '[name="[' + id + '][',
			all_input_fields = $parent.find('[name^="[' + id  + ']"]'),
			$elem = null,
			index = 0,
			changed = [],
			existing_val = null;
		for (index = 0; index < all_input_fields.length; ++index){
			$elem = $(all_input_fields[index]);
			key = parse_key_from_name($elem.attr('name'));
			if (key in default_setting){
				if ('object' === typeof imported_setting[key]) {
						post_key = parse_second_key_from_name($elem.attr('name'));
						existing_val = $elem.prop('checked');
						if ('true' === imported_setting[key][post_key]) {
							if (!existing_val) {
								$elem.prop('checked', true);
								changed.push($elem);
							}
						} else {
							if (existing_val) {
								$elem.prop('checked', false);
								changed.push($elem);
							}
						}
				} else if ('signup-form' === key || 'signup-form-name-field' === key || 'signup-form-email-field' === key){
					continue;
				} else {
					if (key in imported_setting) {
						val = imported_setting[key];
						if ('string' === typeof val) {
							val = val.replace(/&quot;/g, '"');
							val = val.replace(/&#039;/g, "'");
							val = val.replace(/&lt;/g, '<');
							val = val.replace(/&gt;/g, '>');
							val = val.replace(/&amp;/g, '&');
						}
					} else {
						val = default_setting[key];
						if (typeof val === 'string') {
							val = val.replace(/{{num}}/g, id);
						}
					}
					if ($elem.is(':checkbox')) {
						existing_val = $elem.prop('checked');
						if ('true' === val) {
							if (!existing_val) {
								$elem.prop('checked', true);
								changed.push($elem);
							}
						} else {
							if (existing_val) {
								$elem.prop('checked', false);
								changed.push($elem);
							}
						}
					} else {
						existing_val = $elem.val();
						if (val !== existing_val) {
							$elem.val(val);
							changed.push($elem);
						}
					}
				}
			}
		}

		/* integration settings */
		if ('signup-form' in default_setting) {
			if ('signup-form' in imported_setting) {
				val = imported_setting['signup-form'];
			} else {
				val = default_setting['signup-form'];
			}
			changed.push(all_input_fields.find(base_name + 'signup-form]"]').val(val));
			if ('signup-form-name-field' in imported_setting) {
				val = imported_setting['signup-form-name-field'];
			} else {
				val = default_setting['signup-form-name-field'];
			}
			all_input_fields.find(base_name + 'signup-form-name-field]"]').val(val);
			if ('signup-form-email-field' in imported_setting) {
				val = imported_setting['signup-form-email-field'];
			} else {
				val = default_setting['signup-form-email-field'];
			}
			all_input_fields.find(base_name + 'signup-form-email-field]"]').val(val);
			if ('signup-form-lname-field' in imported_setting) {
				val = imported_setting['signup-form-lname-field'];
			} else {
				val = default_setting['signup-form-lname-field'];
			}
			all_input_fields.find(base_name + 'signup-form-lname-field]"]').val(val);
		}
		for (index = 0; index < changed.length; ++index){
			changed[index].change();
		}
	}
	$('#popupally-import-file').change(function(e){
		if (e.target.files[0]) {
			$('#import-button').show();
			var index = e.target.files[0].name.indexOf(' - '),
				num = e.target.files[0].name.substring(0, index);
			if ($('#popupally-import-selection option[value="' + num + '"]').length !== 0) {
				$('#popupally-import-selection').val(num);
			}
		} else {
			$('#import-button').hide();
		}
	});
	$('[import-selection]').click(function(e) {
		var selector = $(this).attr('import-selection'),
		id = $(selector).val(),
		file = document.getElementById('popupally-import-file').files[0],
		name = document.getElementById('popupally-import-file').files[0].name;
		if (file) {
			var conf = confirm("Import operation will overwrite the current settings for Popup #" + id + ".\nThis operation cannot be undone. Do you want to continue?");
			if(conf !== true){
				return false;
			}
			var wait_overlay = $('#popupally-import-wait-overlay');
			wait_overlay.show();
			var reader = new FileReader();
			reader.onload = function(e) {
				try{
					var all_lines = e.target.result,
						results = jQuery.parseJSON(all_lines),
						reset_attr = 'import-reset-' + id;

					if (!('display' in results) || !('style' in results)) {
						$('#import-status').text('Invalid .popupally file. Cannot find "Display Settings" and/or "Style Settings"');
					}
					var display = results['display'],
							style = results['style'];
					$('['+reset_attr+']').each(function() {
						var reset_value = $(this).attr(reset_attr);
						$(this).val(reset_value).change();
					});
					if (!('advanced' in style) || "false" === style['advanced']) {
						delete style['popup-selector'];
						delete style['popup-class'];
						delete style['close-trigger'];
						delete style['cookie-name'];
					}
					assign_import_values(popupally_pro_data_object.display_setting_variable, id, popupally_pro_data_object.display_default_setting, display);
					assign_import_values(popupally_pro_data_object.style_setting_variable, id, popupally_pro_data_object.style_default_setting, style);
					alert("Import successful:\n[" + name + "] => Popup #" + id);
				}catch(e){
					alert("Import failed due to erro:\n[" + e + "]\nPlease send the error message to AmbitionAlly support along with the .popupally file");
				}finally{
					wait_overlay.hide();
				}
			}
			reader.readAsText(file);
		}
		e.stopPropagation();
		return false;
	});
	function update_selected_status(elem) {
		var num_selector = $(elem).attr('update-num-trigger');

		$(elem).val($(num_selector + ':checked').length);
	}
	$('[update-num-trigger]').each(function(index, elem) {
		var selector = $(elem).attr('update-num-trigger');
		$(document).on('change propertychange', selector, function(e) {
			update_selected_status(elem);
		});
		update_selected_status(elem);
	});
	all_popupally_pro_tab_group.click(function(e) {
		var selector = $(this).attr('tab-group'),
			target = $(this).attr('target'),
			active = $(this).attr('active-class'),
			$tabs = $('[' + selector + ']');
		all_popupally_pro_tab_group.filter('[tab-group=' + selector + ']').removeClass(active);
		$(this).addClass(active);
		$tabs.filter('[' + selector + '!=' + target + ']').hide();
		$tabs.filter('[' + selector + '=' + target + ']').show();
	});
	all_popupally_pro_name_sync_master.change(function(e){
		var id = $(this).attr('name-sync-master'),
			val = $(this).val();
		all_popupally_pro_name_sync_text.filter("[name-sync-text="+id+"]").text(val);
		all_popupally_pro_name_sync_val.filter("[name-sync-val="+id+"]").val(val);
	});
	all_popupally_pro_name_sync_val.change(function(e){
		var id = $(this).attr('name-sync-val'),
			val = $(this).val();
		all_popupally_pro_name_sync_master.filter("[name-sync-master="+id+"]").val(val).change();
	});
	$(".popupally-name-edit").click(function(e){
		e.stopPropagation();
		return false;
	});
	$(".popupally-name-edit").focusout(function(e){
		var id = $(this).attr('data-dependency');
		$("#" + id).val('display').change();
	});
	$(".popupally-name-edit").keypress(function(e){
		var code = e.keyCode || e.which;
		if(code == 13) { //Enter keycode
			var id = $(this).attr('data-dependency');
			$("#" + id).val('display').change();
		}
	});
	$(".trigger-follow-scroll-resize").on('change propertychange keyup input paste', function(e) {
		resize_follow_scroll();
	});

	function validateXML(text) {
		// code for IE
		if (window.ActiveXObject) {
			var xmlDoc = new ActiveXObject("Microsoft.XMLDOM");
			xmlDoc.async=false;
			xmlDoc.loadXML(text);
			if(xmlDoc.parseError.errorCode!=0){
				return 'Invalid HTML code. Please make sure all open tags have the corresponding close tag';
			}
		} else if (document.implementation.createDocument) {// code for Mozilla, Firefox, Opera, etc.
			try {
				var parser=new DOMParser();
				var xmlDoc=parser.parseFromString(text,"application/xml");
			} catch(err) {
				return 'Invalid HTML code. Please make sure all open tags have the corresponding close tag';
			}

			if (xmlDoc.getElementsByTagName("parsererror").length>0) {
				return 'Invalid HTML code. Please make sure all open tags have the corresponding close tag';
			}
		}
		return '';
	}
	$("[html-error-check]").change(function() {
		var error = $(this).attr('html-error-check'),
			code = $(this).val();
		if (code) {
			$(error).text(validateXML('<div>' + code + '</div>'));
		}
	});
	$(".popupally-pro-tab-label").mouseenter(function() {
		$(this).css('border-width', '1px').animate({width:"160px"}, 500);
	});
	$(".popupally-pro-tab-label").mouseleave(function() {
		$(this).animate({width:"30px"}, 500).css('border-width', '0');
	});
	$(".popupally-no-follow-scroll").on('click change', function() {
		if ($(this).hasClass('popupally-pro-setting-tab-active')) {
			popupally_pro_follow_scroll = null;
		}
	});
	all_popupally_pro_update_follow_scroll_group.on('change', function() {
		var $this = $(this),
			is_checked = $this.prop('checked'),
			id = $this.attr('popup-id');
		if (is_checked) {
			update_follow_scroll(id, popupally_pro_template_selection.filter('[popup-id="'+id+'"]').val());
		}
	});
	
	all_popupally_pro_follow_scroll.resize(function(){
		var height = $(this).height() + 30,
		follow_selector = $(this).attr('margin-before');
		$(follow_selector).css('margin-top', height+'px');
	});
	popupally_pro_hide_form_selection.change(function() {
		var $this = $(this),
			is_checked = $this.prop('checked'),
			hide_target = $this.attr("signup-form-hide"),
			id = $this.attr('popup-id'),
			$target = all_popupally_pro_signup_fields.filter('[popup-id="'+id+'"][signup-html-template="'+hide_target+'"]');
		if (is_checked) {
			$target.hide();
		} else {
			$target.show();
		}
	});
	$(".popupally-update-follow-scroll-tab").on('click change', function() {
		if ($(this).hasClass('popupally-pro-setting-tab-active')) {
			var opened = all_popupally_pro_update_follow_scroll_group.filter(':checked');
			if (opened.length > 0) {
				opened.change();
			} else {
				popupally_pro_follow_scroll = null;
			}
		}
	}).change();
});
