<?php
if (!class_exists('PopupAllyProBigLogoTemplate')) {
	class PopupAllyProBigLogoTemplate extends PopupAllyProTemplate {
		public function __construct() {
			parent::__construct();
			$this->uid = 'tozpom';
			$this->template_name = 'Edge to Edge';
			$this->template_order = 4;

			$this->backend_php = dirname(__FILE__) . '/backend/big-logo-pro-preview.php';
			$this->display_type_warning = array('timed'=>false, 'exit-intent'=>false, 'scroll'=>false, 'click'=>false, 'embedded'=>true);
			$this->style_hide_signup_fields = array('form'=>false, 'name'=>'tozpom-hide-name-field', 'lname'=>true, 'email'=>false);

			// 0: front end html, 1: front end embedded, 2: backend preview
			$this->popup_html_template_files = array(
				0 => dirname(__FILE__) . '/frontend/big-logo-pro-popup.php',
				1 => dirname(__FILE__) . '/frontend/big-logo-pro-embedded.php',
				2 => dirname(__FILE__) . '/backend/big-logo-pro-preview-template.php',
				3 => dirname(__FILE__) . '/backend/big-logo-pro-960-preview-template.php',
				4 => dirname(__FILE__) . '/backend/big-logo-pro-640-preview-template.php',
			);
			// 0: front end; 1: backend, 2: front end top margin
			$this->popup_css_template_files = array(
				0 => dirname(__FILE__) . '/frontend/big-logo-pro-popup.css',
				1 => dirname(__FILE__) . '/backend/big-logo-pro-preview-popup.css',
				2 => dirname(__FILE__) . '/frontend/big-logo-pro-popup-top-margin.css',
			);

			$this->frontend_css = dirname(__FILE__) . '/frontend/big-logo-pro-popup.css';
			$this->frontend_php = dirname(__FILE__) . '/frontend/big-logo-pro-popup.php';
			$this->frontend_embedded_php = dirname(__FILE__) . '/frontend/big-logo-pro-embedded.php';

			$this->html_mapping = array(
				'tozpom-subscribe-button-text', 'sign-up-form-action', 'tozpom-sign-up-form-name-field',
				'sign-up-form-email-field', 'tozpom-name-placeholder', 'tozpom-email-placeholder', 'tozpom-overlay-close-trigger', 'tozpom-name-input-type');
			$this->no_escape_html_mapping = array('tozpom-headline', 'tozpom-privacy-text', 'tozpom-preview-hide-name');
			$this->default_values = array(
				'tozpom-background-color' => '#fefefe',
				'tozpom-background-image-url' => '',
				'tozpom-background-image' => 'none',
				'tozpom-width' => '650',
				'tozpom-height' => '400',
				'tozpom-half-width' => '325',
				'tozpom-half-height' => '200',
				'tozpom-headline' => "Enter your name and email and get the weekly newsletter... it's FREE!",
				'tozpom-headline-margin-top' => "0",
				'tozpom-headline-margin-bottom' => "0",
				'tozpom-headline-font' => '"Palatino Linotype", "Book Antiqua", Palatino, serif',
				'tozpom-headline-color' => "#444444",
				'tozpom-headline-font-size' => "28",
				'tozpom-headline-font-weight' => "700",
				'tozpom-headline-line-height' => "30",
				'tozpom-headline-align' => "center",
				'tozpom-logo-img-url' => PopupAllyPro::$PLUGIN_URI . 'resource/img/pink-tools.png',
				'tozpom-logo-img' => 'none',
				'tozpom-logo-img-width' => "650",
				'tozpom-logo-img-height' => "100",
				'tozpom-logo-img-margin-top' => "20",
				'tozpom-logo-img-margin-bottom' => "20",
				'tozpom-name-placeholder' => 'Enter your first name here',
				'tozpom-name-font' => 'Arial, Helvetica, sans-serif',
				'tozpom-name-color' => "#444444",
				'tozpom-name-background-color' => "#f6f6f6",
				'tozpom-name-font-size' => "16",
				'tozpom-name-line-height' => "21",
				'tozpom-name-font-weight' => "400",
				'tozpom-name-padding-top' => '15',
				'tozpom-name-padding-bottom' => '15',
				'tozpom-name-padding-left' => '12',
				'tozpom-name-padding-right' => '12',
				'tozpom-name-width' => '100%',
				'tozpom-name-align' => "left",
				'tozpom-name-border-radius' => "3",
				'tozpom-hide-name-field' => "false",
				'tozpom-email-placeholder' => 'Enter a valid email here',
				'tozpom-email-font' => 'Arial, Helvetica, sans-serif',
				'tozpom-email-color' => "#444444",
				'tozpom-email-background-color' => "#f6f6f6",
				'tozpom-email-font-size' => "16",
				'tozpom-email-line-height' => "21",
				'tozpom-email-font-weight' => "400",
				'tozpom-email-padding-top' => '15',
				'tozpom-email-padding-bottom' => '15',
				'tozpom-email-padding-left' => '12',
				'tozpom-email-padding-right' => '12',
				'tozpom-email-width' => '100%',
				'tozpom-email-align' => "left",
				'tozpom-email-border-radius' => "3",
				'tozpom-email-margin-top' => "10",
				'tozpom-subscribe-button-text' => 'Subscribe',
				'tozpom-subscribe-button-text-font' => 'Arial, Helvetica, sans-serif',
				'tozpom-subscribe-button-text-color' => "#ffffff",
				'tozpom-subscribe-button-text-font-size' => "22",
				'tozpom-subscribe-button-text-font-weight' => "700",
				'tozpom-subscribe-button-text-line-height' => "27",
				'tozpom-subscribe-button-text-align' => "center",
				'tozpom-subscribe-button-text-padding-top' => '15',
				'tozpom-subscribe-button-text-padding-bottom' => '15',
				'tozpom-subscribe-button-text-width' => '100%',
				'tozpom-subscribe-button-text-border-radius' => "3",
				'tozpom-subscribe-button-color' => '#00c98d',
				'tozpom-subscribe-button-margin-top' => "10",
				'tozpom-subscribe-button-margin-bottom' => "10",
				'tozpom-privacy-text' => 'Your information will *never* be shared or sold to a 3rd party.',
				'tozpom-privacy-text-font' => '"Palatino Linotype", "Book Antiqua", Palatino, serif',
				'tozpom-privacy-text-color' => "#444444",
				'tozpom-privacy-text-font-size' => "14",
				'tozpom-privacy-text-font-weight' => "400",
				'tozpom-privacy-text-line-height' => "14",
				'tozpom-privacy-text-align' => "center",
				'tozpom-privacy-text-margin-top' => "10",
				'tozpom-privacy-text-margin-bottom' => "10",
				'tozpom-overlay-color' => "#505050",
				'tozpom-overlay-opacity' => '0.5',
				'tozpom-overlay-color-rgba' => '80,80,80,0.5',
				'tozpom-disable-overlay-close' => "false",
				'tozpom-display-headline' => 'block',
				'tozpom-display-privacy' => 'block',

				'tozpom-width-960' => '650',
				'tozpom-height-960' => '400',
				'tozpom-half-width-960' => '325',
				'tozpom-half-height-960' => '200',
				'tozpom-headline-960-margin-top' => "0",
				'tozpom-headline-960-margin-bottom' => "0",
				'tozpom-headline-960-font-size' => "28",
				'tozpom-headline-960-line-height' => "30",
				'tozpom-logo-img-960-width' => "650",
				'tozpom-logo-img-960-height' => "100",
				'tozpom-logo-img-960-margin-top' => "20",
				'tozpom-logo-img-960-margin-bottom' => "20",
				'tozpom-name-960-font-size' => "16",
				'tozpom-name-960-line-height' => "21",
				'tozpom-name-960-padding-top' => '15',
				'tozpom-name-960-padding-bottom' => '15',
				'tozpom-name-960-padding-left' => '12',
				'tozpom-name-960-padding-right' => '12',
				'tozpom-name-960-width' => '100%',
				'tozpom-name-960-border-radius' => "3",
				'tozpom-email-960-font-size' => "16",
				'tozpom-email-960-line-height' => "21",
				'tozpom-email-960-padding-top' => '15',
				'tozpom-email-960-padding-bottom' => '15',
				'tozpom-email-960-padding-left' => '12',
				'tozpom-email-960-padding-right' => '12',
				'tozpom-email-960-width' => '100%',
				'tozpom-email-960-border-radius' => "3",
				'tozpom-email-960-margin-top' => "10",
				'tozpom-subscribe-button-text-960-font-size' => "22",
				'tozpom-subscribe-button-text-960-line-height' => "27",
				'tozpom-subscribe-button-text-960-padding-top' => '15',
				'tozpom-subscribe-button-text-960-padding-bottom' => '15',
				'tozpom-subscribe-button-text-960-width' => '100%',
				'tozpom-subscribe-button-text-960-border-radius' => "3",
				'tozpom-subscribe-button-960-margin-top' => "10",
				'tozpom-subscribe-button-960-margin-bottom' => "10",
				'tozpom-privacy-text-960-font-size' => "14",
				'tozpom-privacy-text-960-line-height' => "14",
				'tozpom-privacy-text-960-margin-top' => "10",
				'tozpom-privacy-text-960-margin-bottom' => "10",

				'tozpom-width-640' => '650',
				'tozpom-height-640' => '400',
				'tozpom-half-width-640' => '325',
				'tozpom-half-height-640' => '200',
				'tozpom-headline-640-margin-top' => "0",
				'tozpom-headline-640-margin-bottom' => "0",
				'tozpom-headline-640-font-size' => "28",
				'tozpom-headline-640-line-height' => "30",
				'tozpom-logo-img-640-width' => "650",
				'tozpom-logo-img-640-height' => "100",
				'tozpom-logo-img-640-margin-top' => "20",
				'tozpom-logo-img-640-margin-bottom' => "20",
				'tozpom-name-640-font-size' => "16",
				'tozpom-name-640-line-height' => "21",
				'tozpom-name-640-padding-top' => '15',
				'tozpom-name-640-padding-bottom' => '15',
				'tozpom-name-640-padding-left' => '12',
				'tozpom-name-640-padding-right' => '12',
				'tozpom-name-640-width' => '100%',
				'tozpom-name-640-border-radius' => "3",
				'tozpom-email-640-font-size' => "16",
				'tozpom-email-640-line-height' => "21",
				'tozpom-email-640-padding-top' => '15',
				'tozpom-email-640-padding-bottom' => '15',
				'tozpom-email-640-padding-left' => '12',
				'tozpom-email-640-padding-right' => '12',
				'tozpom-email-640-width' => '100%',
				'tozpom-email-640-border-radius' => "3",
				'tozpom-email-640-margin-top' => "10",
				'tozpom-subscribe-button-text-640-font-size' => "22",
				'tozpom-subscribe-button-text-640-line-height' => "27",
				'tozpom-subscribe-button-text-640-padding-top' => '15',
				'tozpom-subscribe-button-text-640-padding-bottom' => '15',
				'tozpom-subscribe-button-text-640-width' => '100%',
				'tozpom-subscribe-button-text-640-border-radius' => "3",
				'tozpom-subscribe-button-640-margin-top' => "10",
				'tozpom-subscribe-button-640-margin-bottom' => "10",
				'tozpom-privacy-text-640-font-size' => "14",
				'tozpom-privacy-text-640-line-height' => "14",
				'tozpom-privacy-text-640-margin-top' => "10",
				'tozpom-privacy-text-640-margin-bottom' => "10",
			);
			$this->style_template_advanced_customization = array(
				'tozpom-headline' => array(0, '.tozpom-preview-headline', '#tozpom-preview-headline'),
				'tozpom-privacy-text' => array(0, '.tozpom-preview-privacy-text', '#tozpom-preview-privacy-text'),
				'tozpom-name' => array(1, '.tozpom-preview-name', '#tozpom-preview-name'),
				'tozpom-email' => array(1, '.tozpom-preview-email', '#tozpom-preview-email'),
				'tozpom-subscribe-button-text' => array(2, '.tozpom-preview-subscribe-button', '#tozpom-preview-subscribe-button'),
				'tozpom-headline-960' => array(3, '#tozpom-preview-headline-960'),
				'tozpom-privacy-text-960' => array(3, '#tozpom-preview-privacy-text-960'),
				'tozpom-name-960' => array(4, '#tozpom-preview-name-960'),
				'tozpom-email-960' => array(4, '#tozpom-preview-email-960'),
				'tozpom-subscribe-button-text-960' => array(5, '#tozpom-preview-subscribe-button-960'),
				'tozpom-headline-640' => array(3, '#tozpom-preview-headline-640'),
				'tozpom-privacy-text-640' => array(3, '#tozpom-preview-privacy-text-640'),
				'tozpom-name-640' => array(4, '#tozpom-preview-name-640'),
				'tozpom-email-640' => array(4, '#tozpom-preview-email-640'),
				'tozpom-subscribe-button-text-640' => array(5, '#tozpom-preview-subscribe-button-640'),
			);
			$this->style_template_checked_replace = array(
				'tozpom-hide-name-field',
				'tozpom-disable-overlay-close',
			);
		}

		public function sanitize_style($setting, $id, $is_active = false) {
			$setting = parent::sanitize_style($setting, $id, $is_active);
			PopupAllyProTemplate::save_uploaded_image($setting, 'tozpom-background-img-action', 'tozpom-img-file-', $id, 'tozpom-background-image-url');
			PopupAllyProTemplate::save_uploaded_image($setting, 'tozpom-logo-img-action', 'tozpom-logo-img-file-', $id, 'tozpom-logo-img-url', 'tozpom-logo-img');
			return $setting;
		}

		public function prepare_for_code_generation($id, $style, $all_style) {
			$style['tozpom-background-image'] = PopupAllyProTemplate::image_url_code_generation($style, 'tozpom-background-image-url');
			$style['tozpom-logo-img'] = PopupAllyProTemplate::image_url_code_generation($style, 'tozpom-logo-img-url');

			$style['tozpom-half-width'] = intval($style['tozpom-width']) / 2;
			$style['tozpom-half-height'] = intval($style['tozpom-height']) / 2;
			$style['tozpom-half-width-960'] = intval($style['tozpom-width-960']) / 2;
			$style['tozpom-half-height-960'] = intval($style['tozpom-height-960']) / 2;
			$style['tozpom-half-width-640'] = intval($style['tozpom-width-640']) / 2;
			$style['tozpom-half-height-640'] = intval($style['tozpom-height-640']) / 2;

			// disable background close trigger
			if ('true' === $style['tozpom-disable-overlay-close']) {
				$style['tozpom-overlay-close-trigger'] = '';
			} else {
				$style['tozpom-overlay-close-trigger'] = ' popup-click-close-trigger-' . $id;
			}

			$style['used-sign-up-form-fields'] = array($style['sign-up-form-email-field']);

			PopupAllyProTemplate::process_field_hidden_status($style, 'tozpom-hide-name-field', 'tozpom-name-input-type', 'tozpom-preview-hide-name', 'tozpom-sign-up-form-name-field', 'sign-up-form-name-field');

			$style['tozpom-overlay-color-rgba'] = PopupAllyProTemplate::hex_to_rgb($style['tozpom-overlay-color'], $style['tozpom-overlay-opacity']);
			return $style;
		}
		public function generate_preview_popup_html($id, $setting) {
			$generated_templates = array();
			for ($i=2;$i<=4;++$i) {
				$template = $this->get_popup_html_template($i);
				$generated_templates[$i] = $this->generate_popup_html_from_template($id, $setting, $template);
			}
			return $generated_templates;
		}
		public function show_style_settings($id, $setting) {
			$code = PopupAllyPro::get_popup_code();
			$preview_code = $code[$id]['preview_html'][$this->uid];
			$html = $this->get_style_setting_template();
			$variable_name = '[' . $id . ']';

			foreach($this->style_template_advanced_customization as $name => $tuple) {
				$advanced_edit = PopupAllyProTemplate::generate_advanced_customization_code($id, $variable_name, $setting, $name, $tuple);

				$html = str_replace("{{{$name}-advanced}}", $advanced_edit, $html);
			}
			$html = str_replace('{{id}}', $id, $html);
			for ($i=2;$i<=4;++$i) {
				$html = str_replace("{{preview-code-$i}}", $preview_code[$i], $html);
			}
			$html = str_replace('{{variable_name}}', $variable_name, $html);
			$html = PopupAllyProTemplate::replace_image_placeholders($setting, $html, 'tozpom-background-image-url', 'tozpom-background-img-action');
			$html = PopupAllyProTemplate::replace_image_placeholders($setting, $html, 'tozpom-logo-img-url', 'tozpom-logo-img-action');
			$html = str_replace('{{tozpom-hide-name-field-true-hide}}', 'true' === $setting['tozpom-hide-name-field'] ? 'style="display:none;"' : '', $html);

			// the order is important, as style_template_checked_replace is a subset of default_values
			foreach($this->style_template_checked_replace as $param) {
				$html = str_replace("{{{$param}}}", 'true' === $setting[$param] ? 'checked' : '', $html);
			}
			foreach($this->default_values as $param  => $default_value) {
				$html = str_replace("{{{$param}}}", esc_attr($setting[$param]), $html);
			}
			return $html;
		}
	}
	PopupAllyPro::add_template(new PopupAllyProBigLogoTemplate());
}