<?php
if (!class_exists('PopupAllyProChoiceTemplate')) {
	class PopupAllyProChoiceTemplate extends PopupAllyProTemplate {
		public function __construct() {
			parent::__construct();
			$this->uid = 'oeudhw';
			$this->template_name = 'Simple Choice';
			$this->template_order = 3;

			$this->backend_php = dirname(__FILE__) . '/backend/choice-pro-preview.php';
			$this->display_type_warning = array('timed'=>false, 'exit-intent'=>false, 'scroll'=>false, 'click'=>false, 'embedded'=>true);
			$this->style_hide_signup_fields = array('form'=>true, 'name'=>true, 'lname'=>true, 'email'=>true);

			// 0: front end html, 1: front end embedded, 2: backend preview
			$this->popup_html_template_files = array(
				0 => dirname(__FILE__) . '/frontend/choice-pro-popup.php',
				1 => dirname(__FILE__) . '/frontend/choice-pro-embedded.php',
				2 => dirname(__FILE__) . '/backend/choice-pro-preview-template.php',
				3 => dirname(__FILE__) . '/backend/choice-pro-960-preview-template.php',
				4 => dirname(__FILE__) . '/backend/choice-pro-640-preview-template.php',
			);
			// 0: front end; 1: backend, 2: front end top margin
			$this->popup_css_template_files = array(
				0 => dirname(__FILE__) . '/frontend/choice-pro-popup.css',
				1 => dirname(__FILE__) . '/backend/choice-pro-preview-popup.css',
				2 => dirname(__FILE__) . '/frontend/choice-pro-popup-top-margin.css',
			);

			$this->html_mapping = array('oeudhw-overlay-close-trigger');
			$this->no_escape_html_mapping = array('oeudhw-headline', 'oeudhw-left-choice-text', 'oeudhw-right-choice-text', 'oeudhw-left-click-target', 'oeudhw-right-click-target');
			$this->default_values = array(
				'oeudhw-background-color' => '#ffffff',
				'oeudhw-image-url' => PopupAllyPro::$PLUGIN_URI . 'resource/img/two-options-bg.png',
				'oeudhw-background-image' => 'none',
				'oeudhw-width' => '650',
				'oeudhw-height' => '450',
				'oeudhw-half-width' => '325',
				'oeudhw-half-height' => '225',
				'oeudhw-headline' => 'Could You Use More Traffic, <br/>Subscribers, and Sales in Your<br/>Online Business?',
				'oeudhw-headline-font' => '"Lucida Sans Unicode", "Lucida Grande", sans-serif',
				'oeudhw-headline-color' => "#6d6e71",
				'oeudhw-headline-font-size' => "36",
				'oeudhw-headline-font-weight' => "400",
				'oeudhw-headline-line-height' => "40",
				'oeudhw-headline-margin-top' => "80",
				'oeudhw-headline-margin-bottom' => "0",
				'oeudhw-headline-align' => "center",
				'oeudhw-left-choice-text' => 'Yes!',
				'oeudhw-left-choice-target-type' => 'url',
				'oeudhw-left-choice-url' => '',
				'oeudhw-left-choice-popup-id' => '',
				'oeudhw-left-choice-background-color' => "#FCC302",
				'oeudhw-left-choice-background-image-url' => '',
				'oeudhw-left-choice-background-image' => 'none',
				'oeudhw-left-choice-font' => 'Arial, Helvetica, sans-serif',
				'oeudhw-left-choice-color' => "#ffffff",
				'oeudhw-left-choice-font-size' => "38",
				'oeudhw-left-choice-font-weight' => "400",
				'oeudhw-left-choice-line-height' => "38",
				'oeudhw-left-choice-width' => "229",
				'oeudhw-left-choice-height' => "113",
				'oeudhw-left-choice-margin-top' => "60",
				'oeudhw-left-choice-margin-bottom' => "20",
				'oeudhw-left-choice-align' => "center",
				'oeudhw-right-choice-text' => '',
				'oeudhw-right-choice-target-type' => 'url',
				'oeudhw-right-choice-url' => '',
				'oeudhw-right-choice-popup-id' => '',
				'oeudhw-right-choice-background-color' => "#D9D9DA",
				'oeudhw-right-choice-background-image-url' => PopupAllyPro::$PLUGIN_URI . 'resource/img/no-thanks.png',
				'oeudhw-right-choice-background-image' => 'none',
				'oeudhw-right-choice-font' => '"Palatino Linotype", "Book Antiqua", Palatino, serif',
				'oeudhw-right-choice-color' => "#ffffff",
				'oeudhw-right-choice-font-size' => "38",
				'oeudhw-right-choice-font-weight' => "400",
				'oeudhw-right-choice-line-height' => "38",
				'oeudhw-right-choice-width' => "229",
				'oeudhw-right-choice-height' => "113",
				'oeudhw-right-choice-margin-top' => "60",
				'oeudhw-right-choice-margin-bottom' => "20",
				'oeudhw-right-choice-align' => "center",
				'oeudhw-overlay-color' => "#505050",
				'oeudhw-overlay-opacity' => '0.5',
				'oeudhw-overlay-color-rgba' => '80,80,80,0.5',
				'oeudhw-disable-overlay-close' => 'false',

				'oeudhw-width-960' => '500',
				'oeudhw-height-960' => '346',
				'oeudhw-half-width-960' => '250',
				'oeudhw-half-height-960' => '173',
				'oeudhw-headline-960-font-size' => "28",
				'oeudhw-headline-960-line-height' => "32",
				'oeudhw-headline-960-margin-top' => "60",
				'oeudhw-headline-960-margin-bottom' => "0",
				'oeudhw-left-choice-960-font-size' => "32",
				'oeudhw-left-choice-960-line-height' => "32",
				'oeudhw-left-choice-960-width' => "176",
				'oeudhw-left-choice-960-height' => "87",
				'oeudhw-left-choice-960-margin-top' => "46",
				'oeudhw-left-choice-960-margin-bottom' => "20",
				'oeudhw-right-choice-960-font-size' => "32",
				'oeudhw-right-choice-960-line-height' => "32",
				'oeudhw-right-choice-960-width' => "176",
				'oeudhw-right-choice-960-height' => "87",
				'oeudhw-right-choice-960-margin-top' => "46",
				'oeudhw-right-choice-960-margin-bottom' => "20",

				'oeudhw-width-640' => '400',
				'oeudhw-height-640' => '277',
				'oeudhw-half-width-640' => '200',
				'oeudhw-half-height-640' => '139',
				'oeudhw-headline-640-font-size' => "20",
				'oeudhw-headline-640-line-height' => "24",
				'oeudhw-headline-640-margin-top' => "50",
				'oeudhw-headline-640-margin-bottom' => "0",
				'oeudhw-left-choice-640-font-size' => "28",
				'oeudhw-left-choice-640-line-height' => "28",
				'oeudhw-left-choice-640-width' => "141",
				'oeudhw-left-choice-640-height' => "70",
				'oeudhw-left-choice-640-margin-top' => "28",
				'oeudhw-left-choice-640-margin-bottom' => "20",
				'oeudhw-right-choice-640-font-size' => "28",
				'oeudhw-right-choice-640-line-height' => "28",
				'oeudhw-right-choice-640-width' => "141",
				'oeudhw-right-choice-640-height' => "70",
				'oeudhw-right-choice-640-margin-top' => "28",
				'oeudhw-right-choice-640-margin-bottom' => "20",
			);
			$this->style_template_advanced_customization = array(
				'oeudhw-headline' => array(0, '.oeudhw-preview-headline', '#oeudhw-preview-headline'),
				'oeudhw-left-choice' => array(0, '.oeudhw-preview-left-choice-text', '#oeudhw-preview-left-choice-text'),
				'oeudhw-right-choice' => array(0, '.oeudhw-preview-right-choice-text', '#oeudhw-preview-right-choice-text'),
				'oeudhw-headline-960' => array(3, '.oeudhw-preview-headline-960'),
				'oeudhw-left-choice-960' => array(3, '#oeudhw-preview-left-choice-960-text'),
				'oeudhw-right-choice-960' => array(3, '#oeudhw-preview-right-choice-960-text'),
				'oeudhw-headline-640' => array(3, '.oeudhw-preview-headline-640'),
				'oeudhw-left-choice-640' => array(3, '#oeudhw-preview-left-choice-640-text'),
				'oeudhw-right-choice-640' => array(3, '#oeudhw-preview-right-choice-640-text'),
			);
			$this->style_template_checked_replace = array(
				'oeudhw-disable-overlay-close',
			);
		}

		public function do_activation_actions(&$new_style, &$lite_style) {
			foreach($lite_style as $id => $setting) {
				if (isset($setting['oeudhw-text-color'])) {
					$new_style[$id]['oeudhw-headline-color'] = $setting['oeudhw-text-color'];
				}
			}
		}

		public function sanitize_style($setting, $id, $is_active = false) {
			$setting = parent::sanitize_style($setting, $id, $is_active);
			PopupAllyProTemplate::save_uploaded_image($setting, 'oeudhw-background-img-action', 'oeudhw-img-file-', $id, 'oeudhw-image-url');
			PopupAllyProTemplate::save_uploaded_image($setting, 'oeudhw-left-choice-background-img-action', 'oeudhw-left-choice-img-file-', $id, 'oeudhw-left-choice-background-image-url');
			PopupAllyProTemplate::save_uploaded_image($setting, 'oeudhw-right-choice-background-img-action', 'oeudhw-right-choice-img-file-', $id, 'oeudhw-right-choice-background-image-url');
			return $setting;
		}

		public function prepare_for_code_generation($id, $style, $all_style) {
			$style['oeudhw-background-image'] = PopupAllyProTemplate::image_url_code_generation($style, 'oeudhw-image-url');
			$style['oeudhw-left-choice-background-image'] = PopupAllyProTemplate::image_url_code_generation($style, 'oeudhw-left-choice-background-image-url');
			$style['oeudhw-right-choice-background-image'] = PopupAllyProTemplate::image_url_code_generation($style, 'oeudhw-right-choice-background-image-url');

			$style['oeudhw-half-width'] = intval($style['oeudhw-width']) / 2;
			$style['oeudhw-half-height'] = intval($style['oeudhw-height']) / 2;
			$style['oeudhw-half-width-960'] = intval($style['oeudhw-width-960']) / 2;
			$style['oeudhw-half-height-960'] = intval($style['oeudhw-height-960']) / 2;
			$style['oeudhw-half-width-640'] = intval($style['oeudhw-width-640']) / 2;
			$style['oeudhw-half-height-640'] = intval($style['oeudhw-height-640']) / 2;

			// disable background close trigger
			if ('true' === $style['oeudhw-disable-overlay-close']) {
				$style['oeudhw-overlay-close-trigger'] = '';
			} else {
				$style['oeudhw-overlay-close-trigger'] = ' popup-click-close-trigger-' . $id;
			}

			$style['used-sign-up-form-fields'] = array();

			$style['oeudhw-overlay-color-rgba'] = PopupAllyProTemplate::hex_to_rgb($style['oeudhw-overlay-color'], $style['oeudhw-overlay-opacity']);

			$style['oeudhw-left-click-target'] = $style['oeudhw-left-choice-target-type'] === 'popup' ? 'svvuyx-redirect-popup="' . esc_attr($all_style[$style['oeudhw-left-choice-popup-id']]['popup-selector']) . '"' : 'svvuyx-redirect-url="' . esc_attr($style['oeudhw-left-choice-url']) . '"';
			$style['oeudhw-right-click-target'] = $style['oeudhw-right-choice-target-type'] === 'popup' ? 'svvuyx-redirect-popup="' . esc_attr($all_style[$style['oeudhw-right-choice-popup-id']]['popup-selector']) . '"' : 'svvuyx-redirect-url="' . esc_attr($style['oeudhw-right-choice-url']) . '"';
			return $style;
		}
		public function generate_preview_popup_html($id, $setting) {
			$generated_templates = array();
			for ($i=2;$i<=4;++$i) {
				$template = $this->get_popup_html_template($i);
				$generated_templates[$i] = $this->generate_popup_html_from_template($id, $setting, $template);
			}
			return $generated_templates;
		}
		public function show_style_settings($id, $setting) {
			$code = PopupAllyPro::get_popup_code();
			$preview_code = $code[$id]['preview_html'][$this->uid];
			$html = $this->get_style_setting_template();
			$variable_name = '[' . $id . ']';

			foreach($this->style_template_advanced_customization as $name => $tuple) {
				$advanced_edit = PopupAllyProTemplate::generate_advanced_customization_code($id, $variable_name, $setting, $name, $tuple);

				$html = str_replace("{{{$name}-advanced}}", $advanced_edit, $html);
			}

			$html = str_replace('{{id}}', $id, $html);
			for ($i=2;$i<=4;++$i) {
				$html = str_replace("{{preview-code-$i}}", $preview_code[$i], $html);
			}
			$html = str_replace('{{variable_name}}', $variable_name, $html);

			$html = PopupAllyProTemplate::replace_image_placeholders($setting, $html, 'oeudhw-image-url', 'oeudhw-background-img-action');
			$html = PopupAllyProTemplate::replace_image_placeholders($setting, $html, 'oeudhw-left-choice-background-image-url', 'oeudhw-left-choice-background-img-action');
			$html = PopupAllyProTemplate::replace_image_placeholders($setting, $html, 'oeudhw-right-choice-background-image-url', 'oeudhw-right-choice-background-img-action');
			$html = PopupAllyProTemplate::replace_link_type_placeholders($setting, $html, 'oeudhw-left-choice-target-type');
			$html = PopupAllyProTemplate::replace_link_type_placeholders($setting, $html, 'oeudhw-right-choice-target-type');

			// the order is important, as style_template_checked_replace is a subset of default_values
			foreach($this->style_template_checked_replace as $param) {
				$html = str_replace("{{{$param}}}", 'true' === $setting[$param] ? 'checked' : '', $html);
			}
			foreach($this->default_values as $param  => $default_value) {
				$html = str_replace("{{{$param}}}", esc_attr($setting[$param]), $html);
			}
			return $html;
		}

		public function get_popup_dependency(&$style) {
			$dependencies = array();
			if ('popup' === $style['oeudhw-left-choice-target-type']) {
				$dependencies []= $style['oeudhw-left-choice-popup-id'];
			}
			if ('popup' === $style['oeudhw-right-choice-target-type'] && !in_array($style['oeudhw-right-choice-popup-id'], $dependencies)) {
				$dependencies []= $style['oeudhw-right-choice-popup-id'];
			}
			return $dependencies;
		}
	}
	PopupAllyPro::add_template(new PopupAllyProChoiceTemplate());
}
