<?php
if (!class_exists('PopupAllyProDefaultTemplate')) {
	class PopupAllyProDefaultTemplate extends PopupAllyProTemplate {
		public function __construct() {
			parent::__construct();
			$this->uid = 'bxsjbi';
			$this->template_name = 'Tried-and-true';
			$this->template_order = 0;

			$this->backend_php = dirname(__FILE__) . '/backend/default-pro-preview.php';
			$this->display_type_warning = array('timed'=>false, 'exit-intent'=>false, 'scroll'=>false, 'click'=>false, 'embedded'=>true);
			$this->style_hide_signup_fields = array('form'=>false, 'name'=>'hide-name-field', 'lname'=>true, 'email'=>false);

			// 0: front end html, 1: front end embedded, 2: backend preview
			$this->popup_html_template_files = array(
				0 => dirname(__FILE__) . '/frontend/default-pro-popup.php',
				1 => dirname(__FILE__) . '/frontend/default-pro-embedded.php',
				2 => dirname(__FILE__) . '/backend/default-pro-preview-template.php',
			);
			// 0: front end; 1: backend, 2: front end top margin
			$this->popup_css_template_files = array(
				0 => dirname(__FILE__) . '/frontend/default-pro-popup.css',
				1 => dirname(__FILE__) . '/backend/default-pro-preview-popup.css',
				2 => dirname(__FILE__) . '/frontend/default-pro-popup-top-margin.css',
			);

			$this->frontend_css = dirname(__FILE__) . '/frontend/default-pro-popup.css';
			$this->frontend_php = dirname(__FILE__) . '/frontend/default-pro-popup.php';
			$this->frontend_embedded_php = dirname(__FILE__) . '/frontend/default-pro-embedded.php';

			$this->html_mapping = array('image-url',
				'subscribe-button-text', 'sign-up-form-action', 'bxsjbi-sign-up-form-name-field',
				'sign-up-form-email-field', 'name-placeholder', 'email-placeholder', 'overlay-close-trigger', 'name-input-type');
			$this->no_escape_html_mapping = array('headline', 'sales-text', 'privacy-text', 'bxsjbi-preview-hide-name');
			$this->default_values = array(
				'headline' => "Enter your name and email and get the weekly newsletter... it's FREE!",
				'headline-font' => '"Palatino Linotype", "Book Antiqua", Palatino, serif',
				'headline-color' => "#444444",
				'headline-font-size' => "28",
				'headline-font-weight' => "700",
				'headline-line-height' => "30",
				'headline-align' => "center",
				'sales-text' => 'Introduce yourself and your program',
				'sales-text-font' => '"Palatino Linotype", "Book Antiqua", Palatino, serif',
				'sales-text-color' => "#444444",
				'sales-text-font-size' => "24",
				'sales-text-font-weight' => "400",
				'sales-text-line-height' => "28",
				'sales-text-align' => "left",
				'logo-row-margin-top' => "20",
				'logo-row-margin-bottom' => "20",
				'name-placeholder' => 'Enter your first name here',
				'email-placeholder' => 'Enter a valid email here',
				'input-box-font' => 'Arial, Helvetica, sans-serif',
				'input-box-color' => "#444444",
				'input-box-background-color' => "#f6f6f6",
				'input-box-font-size' => "16",
				'input-box-line-height' => "21",
				'input-box-font-weight' => "400",
				'input-box-padding-top' => '15',
				'input-box-padding-bottom' => '15',
				'input-box-padding-left' => '12',
				'input-box-padding-right' => '12',
				'input-box-width' => '100%',
				'input-box-align' => "left",
				'input-box-border-radius' => "3",
				'hide-name-field' => "false",
				'subscribe-button-text' => 'Subscribe',
				'subscribe-button-text-font' => 'Arial, Helvetica, sans-serif',
				'subscribe-button-text-color' => "#ffffff",
				'subscribe-button-text-font-size' => "22",
				'subscribe-button-text-font-weight' => "700",
				'subscribe-button-text-line-height' => "27",
				'subscribe-button-text-align' => "center",
				'subscribe-button-text-padding-top' => '15',
				'subscribe-button-text-padding-bottom' => '15',
				'subscribe-button-text-width' => '100%',
				'subscribe-button-text-border-radius' => "3",
				'subscribe-button-margin-top' => "10",
				'subscribe-button-margin-bottom' => "10",
				'privacy-text' => 'Your information will *never* be shared or sold to a 3rd party.',
				'privacy-text-font' => '"Palatino Linotype", "Book Antiqua", Palatino, serif',
				'privacy-text-color' => "#444444",
				'privacy-text-font-size' => "14",
				'privacy-text-font-weight' => "400",
				'privacy-text-line-height' => "14",
				'privacy-text-align' => "center",
				'privacy-text-margin-top' => "10",
				'privacy-text-margin-bottom' => "10",
				'overlay-color' => "#505050",
				'overlay-opacity' => '0.5',
				'overlay-color-rgba' => '80,80,80,0.5',
				'disable-overlay-close' => "false",
				'background-color' => '#fefefe',
				'subscribe-button-color' => '#00c98d',
				'display-headline' => 'block',
				'display-logo-row' => 'block',
				'display-logo-img' => 'block',
				'display-privacy' => 'block',
				'image-url' => PopupAllyPro::$PLUGIN_URI . 'resource/img/pink-tools.png');
			$this->style_template_advanced_customization = array(
				'headline' => array(0, '#preview-headline'),
				'sales-text' => array(0, '#preview-sales-text'),
				'privacy-text' => array(0, '#privacy-text'),
				'input-box' => array(1, '.preview-input'),
				'subscribe-button-text' => array(2, '#subscribe-button'),
			);
			$this->style_template_checked_replace = array(
				'hide-name-field',
				'disable-overlay-close',
			);
		}

		public function do_activation_actions(&$new_style, &$lite_style) {
			foreach($lite_style as $id => $setting) {
				if (isset($setting['text-color'])) {
					$new_style[$id]['headline-color'] = $new_style[$id]['sales-text-color'] = $new_style[$id]['input-box-color'] = $new_style[$id]['privacy-text-color'] = $setting['text-color'];
				}
			}
		}

		public function sanitize_style($setting, $id, $is_active = false) {
			$setting = parent::sanitize_style($setting, $id, $is_active);
			PopupAllyProTemplate::save_uploaded_image($setting, 'logo-img-action', 'img-file-', $id, 'image-url');
			return $setting;
		}

		public function prepare_for_code_generation($id, $setting, $all_style) {
			// disable background close trigger
			if ('true' === $setting['disable-overlay-close']) {
				$setting['overlay-close-trigger'] = '';
			} else {
				$setting['overlay-close-trigger'] = ' popup-click-close-trigger-' . $id;
			}

			$setting['used-sign-up-form-fields'] = array($setting['sign-up-form-email-field']);

			PopupAllyProTemplate::process_field_hidden_status($setting, 'hide-name-field', 'name-input-type', 'bxsjbi-preview-hide-name', 'bxsjbi-sign-up-form-name-field', 'sign-up-form-name-field');

			$setting['overlay-color-rgba'] = PopupAllyProTemplate::hex_to_rgb($setting['overlay-color'], $setting['overlay-opacity']);
			return $setting;
		}

		public function show_style_settings($id, $setting) {
			$code = PopupAllyPro::get_popup_code();
			$preview_code = $code[$id]['preview_html'][$this->uid];
			$html = $this->get_style_setting_template();
			$variable_name = '[' . $id . ']';

			foreach($this->style_template_advanced_customization as $name => $tuple) {
				$advanced_edit = PopupAllyProTemplate::generate_advanced_customization_code($id, $variable_name, $setting, $name, $tuple);

				$html = str_replace("{{{$name}-advanced}}", $advanced_edit, $html);
			}
			$html = str_replace('{{id}}', $id, $html);
			$html = str_replace('{{preview-code}}', $preview_code, $html);
			$html = str_replace('{{variable_name}}', $variable_name, $html);

			$html = PopupAllyProTemplate::replace_image_placeholders($setting, $html, 'image-url', 'logo-img-action');
			$html = str_replace('{{plsbvs-hide-name-field-true-hide}}', 'true' === $setting['plsbvs-hide-name-field'] ? 'style="display:none;"' : '', $html);

			// the order is important, as style_template_checked_replace is a subset of default_values
			foreach($this->style_template_checked_replace as $param) {
				$html = str_replace("{{{$param}}}", 'true' === $setting[$param] ? 'checked' : '', $html);
			}
			foreach($this->default_values as $param  => $default_value) {
				$html = str_replace("{{{$param}}}", esc_attr($setting[$param]), $html);
			}
			return $html;
		}
	}
	PopupAllyPro::add_template(new PopupAllyProDefaultTemplate());
}