<?php
if (!class_exists('PopupAllyProThreeChoiceTemplate')) {
	class PopupAllyProThreeChoiceTemplate extends PopupAllyProTemplate {
		public function __construct() {
			parent::__construct();
			$this->uid = 'iejsye';
			$this->template_name = 'Three Musketeers';
			$this->template_order = 11;

			$this->backend_php = dirname(__FILE__) . '/backend/three-choice-pro-preview.php';
			$this->style_hide_signup_fields = array('form'=>true, 'name'=>true, 'lname'=>true, 'email'=>true);

			// 0: front end html, 1: front end embedded, 2: backend preview
			$this->popup_html_template_files = array(
				0 => dirname(__FILE__) . '/frontend/three-choice-pro-popup.php',
				1 => dirname(__FILE__) . '/frontend/three-choice-pro-embedded.php',
				2 => dirname(__FILE__) . '/backend/three-choice-pro-preview-template.php',
				3 => dirname(__FILE__) . '/backend/three-choice-pro-960-preview-template.php',
				4 => dirname(__FILE__) . '/backend/three-choice-pro-640-preview-template.php',
			);
			// 0: front end; 1: backend, 2: front end top margin
			$this->popup_css_template_files = array(
				0 => dirname(__FILE__) . '/frontend/three-choice-pro-popup.css',
				1 => dirname(__FILE__) . '/backend/three-choice-pro-preview-popup.css',
				2 => dirname(__FILE__) . '/frontend/three-choice-pro-popup-top-margin.css',
			);

			$this->html_mapping = array('iejsye-overlay-close-trigger');
			$this->no_escape_html_mapping = array('iejsye-headline', 'iejsye-textbox-1', 'iejsye-textbox-2', 'iejsye-choice-1-text', 'iejsye-choice-2-text', 'iejsye-choice-3-text',
				'iejsye-choice-1-click-target', 'iejsye-choice-2-click-target', 'iejsye-choice-3-click-target');
			$this->default_values = array(
				'iejsye-background-color' => '#fefefe',
				'iejsye-background-image-url' => PopupAllyPro::$PLUGIN_URI . 'resource/img/3muskateers-bg.png',
				'iejsye-background-image' => 'none',
				'iejsye-width' => '600',
				'iejsye-height' => '400',
				'iejsye-half-width' => '300',
				'iejsye-half-height' => '200',
				'iejsye-headline' => 'Who is your favorite Musketeer?',
				'iejsye-headline-font' => '"Lucida Sans Unicode", "Lucida Grande", sans-serif',
				'iejsye-headline-color' => "#6d6e71",
				'iejsye-headline-font-size' => "32",
				'iejsye-headline-font-weight' => "700",
				'iejsye-headline-line-height' => "32",
				'iejsye-headline-width' => "500",
				'iejsye-headline-height' => "200",
				'iejsye-headline-align' => "left",
				'iejsye-headline-top' => '30',
				'iejsye-headline-left' => '40',
				'iejsye-textbox-1' => 'Find out what it means about you on the next page!',
				'iejsye-textbox-1-font' => 'Arial, Helvetica, sans-serif',
				'iejsye-textbox-1-color' => "#949494",
				'iejsye-textbox-1-font-size' => "20",
				'iejsye-textbox-1-font-weight' => "700",
				'iejsye-textbox-1-line-height' => "32",
				'iejsye-textbox-1-width' => "500",
				'iejsye-textbox-1-height' => "80",
				'iejsye-textbox-1-align' => "left",
				'iejsye-textbox-1-top' => '345',
				'iejsye-textbox-1-left' => '40',
				'iejsye-textbox-2' => '',
				'iejsye-textbox-2-font' => '"Palatino Linotype", "Book Antiqua", Palatino, serif',
				'iejsye-textbox-2-color' => "#111111",
				'iejsye-textbox-2-font-size' => "24",
				'iejsye-textbox-2-font-weight' => "700",
				'iejsye-textbox-2-line-height' => "32",
				'iejsye-textbox-2-width' => "300",
				'iejsye-textbox-2-height' => "80",
				'iejsye-textbox-2-align' => "left",
				'iejsye-textbox-2-top' => '30',
				'iejsye-textbox-2-left' => '200',
				'iejsye-image-1' => 'none',
				'iejsye-image-1-url' => '',
				'iejsye-image-1-width' => '0',
				'iejsye-image-1-height' => '0',
				'iejsye-image-1-top' => '0',
				'iejsye-image-1-left' => '0',
				'iejsye-image-2' => 'none',
				'iejsye-image-2-url' => '',
				'iejsye-image-2-width' => '0',
				'iejsye-image-2-height' => '0',
				'iejsye-image-2-top' => '0',
				'iejsye-image-2-left' => '0',
				'iejsye-choice-1-text' => 'Athos',
				'iejsye-choice-1-target-type' => 'url',
				'iejsye-choice-1-url' => '',
				'iejsye-choice-1-popup-id' => '',
				'iejsye-choice-1-background-color' => "#74D3FC",
				'iejsye-choice-1-background-image-url' => '',
				'iejsye-choice-1-background-image' => 'none',
				'iejsye-choice-1-font' => 'Arial, Helvetica, sans-serif',
				'iejsye-choice-1-color' => "#ffffff",
				'iejsye-choice-1-font-size' => "38",
				'iejsye-choice-1-font-weight' => "400",
				'iejsye-choice-1-line-height' => "38",
				'iejsye-choice-1-width' => "200",
				'iejsye-choice-1-height' => "60",
				'iejsye-choice-1-top' => "100",
				'iejsye-choice-1-left' => "320",
				'iejsye-choice-1-align' => "center",
				'iejsye-choice-2-text' => 'Porthos',
				'iejsye-choice-2-target-type' => 'url',
				'iejsye-choice-2-url' => '',
				'iejsye-choice-2-popup-id' => '',
				'iejsye-choice-2-background-color' => "#FC893C",
				'iejsye-choice-2-background-image-url' => '',
				'iejsye-choice-2-background-image' => 'none',
				'iejsye-choice-2-font' => 'Arial, Helvetica, sans-serif',
				'iejsye-choice-2-color' => "#ffffff",
				'iejsye-choice-2-font-size' => "38",
				'iejsye-choice-2-font-weight' => "400",
				'iejsye-choice-2-line-height' => "38",
				'iejsye-choice-2-width' => "200",
				'iejsye-choice-2-height' => "60",
				'iejsye-choice-2-top' => "180",
				'iejsye-choice-2-left' => "320",
				'iejsye-choice-2-align' => "center",
				'iejsye-choice-3-text' => 'Aramis',
				'iejsye-choice-3-target-type' => 'url',
				'iejsye-choice-3-url' => '',
				'iejsye-choice-3-popup-id' => '',
				'iejsye-choice-3-background-color' => "#659C95",
				'iejsye-choice-3-background-image-url' => '',
				'iejsye-choice-3-background-image' => 'none',
				'iejsye-choice-3-font' => 'Arial, Helvetica, sans-serif',
				'iejsye-choice-3-color' => "#ffffff",
				'iejsye-choice-3-font-size' => "38",
				'iejsye-choice-3-font-weight' => "400",
				'iejsye-choice-3-line-height' => "38",
				'iejsye-choice-3-width' => "200",
				'iejsye-choice-3-height' => "60",
				'iejsye-choice-3-top' => "260",
				'iejsye-choice-3-left' => "320",
				'iejsye-choice-3-align' => "center",
				'iejsye-overlay-color' => "#505050",
				'iejsye-overlay-opacity' => '0.5',
				'iejsye-overlay-color-rgba' => '80,80,80,0.5',
				'iejsye-disable-overlay-close' => 'false',

				'iejsye-width-960' => '500',
				'iejsye-height-960' => '300',
				'iejsye-half-width-960' => '250',
				'iejsye-half-height-960' => '150',
				'iejsye-headline-960-top' => '20',
				'iejsye-headline-960-left' => '40',
				'iejsye-headline-960-width' => "350",
				'iejsye-headline-960-height' => "80",
				'iejsye-headline-960-font-size' => '24',
				'iejsye-headline-960-line-height' => '24',
				'iejsye-textbox-1-960-top' => '260',
				'iejsye-textbox-1-960-left' => '40',
				'iejsye-textbox-1-960-width' => "400",
				'iejsye-textbox-1-960-height' => "80",
				'iejsye-textbox-1-960-font-size' => '16',
				'iejsye-textbox-1-960-line-height' => '16',
				'iejsye-textbox-2-960-top' => '0',
				'iejsye-textbox-2-960-left' => '0',
				'iejsye-textbox-2-960-width' => "0",
				'iejsye-textbox-2-960-height' => "0",
				'iejsye-textbox-2-960-font-size' => '24',
				'iejsye-textbox-2-960-line-height' => '24',
				'iejsye-image-1-960-width' => '0',
				'iejsye-image-1-960-height' => '0',
				'iejsye-image-1-960-top' => '0',
				'iejsye-image-1-960-left' => '0',
				'iejsye-image-2-960-width' => '0',
				'iejsye-image-2-960-height' => '0',
				'iejsye-image-2-960-top' => '0',
				'iejsye-image-2-960-left' => '0',
				'iejsye-choice-1-960-font-size' => "32",
				'iejsye-choice-1-960-line-height' => "32",
				'iejsye-choice-1-960-width' => "150",
				'iejsye-choice-1-960-height' => "40",
				'iejsye-choice-1-960-top' => "80",
				'iejsye-choice-1-960-left' => "280",
				'iejsye-choice-2-960-font-size' => "32",
				'iejsye-choice-2-960-line-height' => "32",
				'iejsye-choice-2-960-width' => "150",
				'iejsye-choice-2-960-height' => "40",
				'iejsye-choice-2-960-top' => "130",
				'iejsye-choice-2-960-left' => "280",
				'iejsye-choice-3-960-font-size' => "32",
				'iejsye-choice-3-960-line-height' => "32",
				'iejsye-choice-3-960-width' => "150",
				'iejsye-choice-3-960-height' => "40",
				'iejsye-choice-3-960-top' => "180",
				'iejsye-choice-3-960-left' => "280",

				'iejsye-width-640' => '400',
				'iejsye-height-640' => '250',
				'iejsye-half-width-640' => '200',
				'iejsye-half-height-640' => '125',
				'iejsye-headline-640-top' => '15',
				'iejsye-headline-640-left' => '30',
				'iejsye-headline-640-width' => "290",
				'iejsye-headline-640-height' => "80",
				'iejsye-headline-640-font-size' => '20',
				'iejsye-headline-640-line-height' => '20',
				'iejsye-textbox-1-640-top' => '210',
				'iejsye-textbox-1-640-left' => '30',
				'iejsye-textbox-1-640-width' => "350",
				'iejsye-textbox-1-640-height' => "80",
				'iejsye-textbox-1-640-font-size' => '12',
				'iejsye-textbox-1-640-line-height' => '12',
				'iejsye-textbox-2-640-top' => '0',
				'iejsye-textbox-2-640-left' => '0',
				'iejsye-textbox-2-640-width' => "0",
				'iejsye-textbox-2-640-height' => "0",
				'iejsye-textbox-2-640-font-size' => '24',
				'iejsye-textbox-2-640-line-height' => '24',
				'iejsye-image-1-640-width' => '0',
				'iejsye-image-1-640-height' => '0',
				'iejsye-image-1-640-top' => '0',
				'iejsye-image-1-640-left' => '0',
				'iejsye-image-2-640-width' => '0',
				'iejsye-image-2-640-height' => '0',
				'iejsye-image-2-640-top' => '0',
				'iejsye-image-2-640-left' => '0',
				'iejsye-choice-1-640-font-size' => "22",
				'iejsye-choice-1-640-line-height' => "22",
				'iejsye-choice-1-640-width' => "120",
				'iejsye-choice-1-640-height' => "30",
				'iejsye-choice-1-640-top' => "60",
				'iejsye-choice-1-640-left' => "230",
				'iejsye-choice-2-640-font-size' => "22",
				'iejsye-choice-2-640-line-height' => "22",
				'iejsye-choice-2-640-width' => "120",
				'iejsye-choice-2-640-height' => "30",
				'iejsye-choice-2-640-top' => "100",
				'iejsye-choice-2-640-left' => "230",
				'iejsye-choice-3-640-font-size' => "22",
				'iejsye-choice-3-640-line-height' => "22",
				'iejsye-choice-3-640-width' => "120",
				'iejsye-choice-3-640-height' => "30",
				'iejsye-choice-3-640-top' => "140",
				'iejsye-choice-3-640-left' => "230",
			);
			$this->style_template_advanced_customization = array(
				'iejsye-headline' => array(0, '.iejsye-preview-headline', '#iejsye-preview-headline'),
				'iejsye-textbox-1' => array(0, '.iejsye-preview-textbox-1', '#iejsye-preview-textbox-1'),
				'iejsye-textbox-2' => array(0, '.iejsye-preview-textbox-2', '#iejsye-preview-textbox-2'),
				'iejsye-choice-1' => array(0, '.iejsye-preview-choice-1-text', '#iejsye-preview-choice-1-text'),
				'iejsye-choice-2' => array(0, '.iejsye-preview-choice-2-text', '#iejsye-preview-choice-2-text'),
				'iejsye-choice-3' => array(0, '.iejsye-preview-choice-3-text', '#iejsye-preview-choice-3-text'),
				'iejsye-headline-960' => array(3, '#iejsye-preview-headline-960'),
				'iejsye-textbox-1-960' => array(3, '#iejsye-preview-textbox-1-960'),
				'iejsye-textbox-2-960' => array(3, '#iejsye-preview-textbox-2-960'),
				'iejsye-choice-1-960' => array(3, '#iejsye-preview-choice-1-text-960'),
				'iejsye-choice-2-960' => array(3, '#iejsye-preview-choice-2-text-960'),
				'iejsye-choice-3-960' => array(3, '#iejsye-preview-choice-3-text-960'),
				'iejsye-headline-640' => array(3, '#iejsye-preview-headline-640'),
				'iejsye-textbox-1-640' => array(3, '#iejsye-preview-textbox-1-640'),
				'iejsye-textbox-2-640' => array(3, '#iejsye-preview-textbox-2-640'),
				'iejsye-choice-1-640' => array(3, '#iejsye-preview-choice-1-text-640'),
				'iejsye-choice-2-640' => array(3, '#iejsye-preview-choice-2-text-640'),
				'iejsye-choice-3-640' => array(3, '#iejsye-preview-choice-3-text-640'),
			);
			$this->style_template_checked_replace = array(
				'iejsye-disable-overlay-close',
			);
		}

		public function do_activation_actions(&$new_style, &$lite_style) {
			foreach($lite_style as $id => $setting) {
				if (isset($setting['iejsye-text-color'])) {
					$new_style[$id]['iejsye-headline-color'] = $setting['iejsye-text-color'];
				}
			}
		}

		public function sanitize_style($setting, $id, $is_active = false) {
			$setting = parent::sanitize_style($setting, $id, $is_active);
			PopupAllyProTemplate::save_uploaded_image($setting, 'iejsye-background-image-action', 'iejsye-background-image-file-', $id, 'iejsye-background-image-url');
			PopupAllyProTemplate::save_uploaded_image($setting, 'iejsye-image-1-action', 'iejsye-image-1-file-', $id, 'iejsye-image-1-url', 'iejsye-image-1');
			PopupAllyProTemplate::save_uploaded_image($setting, 'iejsye-image-2-action', 'iejsye-image-2-file-', $id, 'iejsye-image-2-url', 'iejsye-image-2');
			return $setting;
		}

		public function prepare_for_code_generation($id, $style, $all_style) {
			$style['iejsye-background-image'] = PopupAllyProTemplate::image_url_code_generation($style, 'iejsye-background-image-url');
			$style['iejsye-image-1'] = PopupAllyProTemplate::image_url_code_generation($style, 'iejsye-image-1-url');
			$style['iejsye-image-2'] = PopupAllyProTemplate::image_url_code_generation($style, 'iejsye-image-2-url');
			$style['iejsye-choice-1-background-image'] = PopupAllyProTemplate::image_url_code_generation($style, 'iejsye-choice-1-background-image-url');
			$style['iejsye-choice-2-background-image'] = PopupAllyProTemplate::image_url_code_generation($style, 'iejsye-choice-2-background-image-url');
			$style['iejsye-choice-3-background-image'] = PopupAllyProTemplate::image_url_code_generation($style, 'iejsye-choice-3-background-image-url');

			$style['iejsye-half-width'] = intval($style['iejsye-width']) / 2;
			$style['iejsye-half-height'] = intval($style['iejsye-height']) / 2;
			$style['iejsye-half-width-960'] = intval($style['iejsye-width-960']) / 2;
			$style['iejsye-half-height-960'] = intval($style['iejsye-height-960']) / 2;
			$style['iejsye-half-width-640'] = intval($style['iejsye-width-640']) / 2;
			$style['iejsye-half-height-640'] = intval($style['iejsye-height-640']) / 2;

			// disable background close trigger
			if ('true' === $style['iejsye-disable-overlay-close']) {
				$style['iejsye-overlay-close-trigger'] = '';
			} else {
				$style['iejsye-overlay-close-trigger'] = ' popup-click-close-trigger-' . $id;
			}

			$style['used-sign-up-form-fields'] = array();

			$style['iejsye-overlay-color-rgba'] = PopupAllyProTemplate::hex_to_rgb($style['iejsye-overlay-color'], $style['iejsye-overlay-opacity']);

			$style['iejsye-choice-1-click-target'] = $style['iejsye-choice-1-target-type'] === 'popup' ? 'svvuyx-redirect-popup="' . esc_attr($all_style[$style['iejsye-choice-1-popup-id']]['popup-selector']) . '"' : 'svvuyx-redirect-url="' . esc_attr($style['iejsye-choice-1-url']) . '"';
			$style['iejsye-choice-2-click-target'] = $style['iejsye-choice-2-target-type'] === 'popup' ? 'svvuyx-redirect-popup="' . esc_attr($all_style[$style['iejsye-choice-2-popup-id']]['popup-selector']) . '"' : 'svvuyx-redirect-url="' . esc_attr($style['iejsye-choice-2-url']) . '"';
			$style['iejsye-choice-3-click-target'] = $style['iejsye-choice-3-target-type'] === 'popup' ? 'svvuyx-redirect-popup="' . esc_attr($all_style[$style['iejsye-choice-3-popup-id']]['popup-selector']) . '"' : 'svvuyx-redirect-url="' . esc_attr($style['iejsye-choice-3-url']) . '"';
			return $style;
		}
		public function generate_preview_popup_html($id, $setting) {
			$generated_templates = array();
			for ($i=2;$i<=4;++$i) {
				$template = $this->get_popup_html_template($i);
				$generated_templates[$i] = $this->generate_popup_html_from_template($id, $setting, $template);
			}
			return $generated_templates;
		}
		public function show_style_settings($id, $setting) {
			$code = PopupAllyPro::get_popup_code();
			$preview_code = $code[$id]['preview_html'][$this->uid];
			$html = $this->get_style_setting_template();
			$variable_name = '[' . $id . ']';

			foreach($this->style_template_advanced_customization as $name => $tuple) {
				$advanced_edit = PopupAllyProTemplate::generate_advanced_customization_code($id, $variable_name, $setting, $name, $tuple);

				$html = str_replace("{{{$name}-advanced}}", $advanced_edit, $html);
			}

			$html = str_replace('{{id}}', $id, $html);
			for ($i=2;$i<=4;++$i) {
				$html = str_replace("{{preview-code-$i}}", $preview_code[$i], $html);
			}
			$html = str_replace('{{variable_name}}', $variable_name, $html);

			$html = PopupAllyProTemplate::replace_image_placeholders($setting, $html, 'iejsye-background-image-url', 'iejsye-background-image-action');
			$html = PopupAllyProTemplate::replace_image_placeholders($setting, $html, 'iejsye-image-1-url', 'iejsye-image-1-action');
			$html = PopupAllyProTemplate::replace_image_placeholders($setting, $html, 'iejsye-image-2-url', 'iejsye-image-2-action');
			$html = PopupAllyProTemplate::replace_image_placeholders($setting, $html, 'iejsye-choice-1-background-image-url', 'iejsye-choice-1-background-img-action');
			$html = PopupAllyProTemplate::replace_image_placeholders($setting, $html, 'iejsye-choice-2-background-image-url', 'iejsye-choice-2-background-img-action');
			$html = PopupAllyProTemplate::replace_image_placeholders($setting, $html, 'iejsye-choice-3-background-image-url', 'iejsye-choice-3-background-img-action');
			$html = PopupAllyProTemplate::replace_link_type_placeholders($setting, $html, 'iejsye-choice-1-target-type');
			$html = PopupAllyProTemplate::replace_link_type_placeholders($setting, $html, 'iejsye-choice-2-target-type');
			$html = PopupAllyProTemplate::replace_link_type_placeholders($setting, $html, 'iejsye-choice-3-target-type');

			// the order is important, as style_template_checked_replace is a subset of default_values
			foreach($this->style_template_checked_replace as $param) {
				$html = str_replace("{{{$param}}}", 'true' === $setting[$param] ? 'checked' : '', $html);
			}
			foreach($this->default_values as $param  => $default_value) {
				$html = str_replace("{{{$param}}}", esc_attr($setting[$param]), $html);
			}
			return $html;
		}
	}
	PopupAllyPro::add_template(new PopupAllyProThreeChoiceTemplate());
}
